const numBubbles = 50;
const colors = ['#e87435', '#061556', '#3357FF', '#0073BB', '#2196f3', '#448aff', '#2B6FC0', '#131C49'];
const body = document.body;
const bubbles = [];
const margin = 10;
const speedMultiplier = 2;

for (let i = 0; i < numBubbles; i++) {
    createBubble();
}

function createBubble() {
    const bubble = document.createElement('div');
    bubble.className = 'bubble';
    bubble.style.width = bubble.style.height = `${Math.random() * (150 - 20) + 20}px`;
    bubble.style.backgroundColor = colors[Math.floor(Math.random() * colors.length)];
    bubble.style.left = `${Math.random() * window.innerWidth}vw`;
    bubble.style.top = `${Math.random() * window.innerHeight}vh`;

    const speedX = (Math.random() - 0.5) * speedMultiplier;
    const speedY = (Math.random() - 0.5) * speedMultiplier;

    body.appendChild(bubble);
    bubbles.push(bubble);

    let previousTimeStamp;

    function moveBubble(timeStamp) {
        if (previousTimeStamp == undefined) previousTimeStamp = timeStamp;

        const deltaTime = timeStamp - previousTimeStamp;

        let left = parseFloat(bubble.style.left);
        let top = parseFloat(bubble.style.top);
        let width = parseFloat(bubble.style.width);
        let height = parseFloat(bubble.style.height);

        let innerWidth = parseFloat(window.innerWidth);
        let innerHeight = parseFloat(window.innerHeight);

        left += speedX * deltaTime / 16.6667;
        top += speedY * deltaTime / 16.6667;

        if (left < 0 - width - margin) left = innerWidth;
        if (left > innerWidth + margin) left = 0 - width;
        if (top < 0 - height - margin) top = innerHeight;
        if (top > innerHeight + margin) top = 0 - height;

        bubble.style.left = `${left}px`;
        bubble.style.top = `${top}px`;

        previousTimeStamp = timeStamp;

        requestAnimationFrame(moveBubble);
    }

    moveBubble();
}

window.addEventListener("flutter-first-frame", function () {
    // document.querySelector('.loading').remove();
    // document.querySelector('.logo').remove();
    bubbles.forEach(bubble => bubble.remove());
});
